use strict;

{
	# Fused: DefaultedHash
package DefaultedHash;

use Tie::Hash;

sub FIRSTKEY()
{
        my $self = $_[0];
        my $a = keys(%{$$self[0]});
        each %{$$self[0]};
}

sub NEXTKEY()
{
        my $self = $_[0];
        return each %{$$self[0]};
}

sub TIEHASH()
{
  my $self=shift;
  my %h=@_;
  my $defaultpath = '';
  my @ret = ( \%h, \$defaultpath );
  return bless \@ret, $self;
}

sub set_path($$)
{
  ${$_[0]}[1] = $_[1];
}

sub FETCH()
{
  my $self=shift;
  my $key=shift;
  my $blog=${$$self[1]};
  while (defined($blog)) {
    if (exists($$self[0]{"$key($blog)"})) {
      return $$self[0]{"$key($blog)"};
    }
    if ($blog=~/\/./s) {
      $blog=~s/\/(.*?)$/\//s;
    } else {
      undef($blog);
    }
  }
  return $$self[0]{$key};
}

sub EXISTS()
{
  my $self=shift;
  my $key=shift;
  my $blog=${$$self[1]};
  while (defined($blog)) {
    if (exists($$self[0]{"$key($blog)"})) {
      return exists($$self[0]{"$key($blog)"});
    }
    if ($blog=~/\/./s) {
      $blog=~s/\/(.*?)$/\//s;
    } else {
      undef($blog);
    }
  }
  return exists($$self[0]{$key});
}

sub STORE($$$)
{
  my ($self, $key, $value) = @_;
  $$self[0]{$key} = $value;
}

1;

}

package Addendat;

use vars qw($O_NOFOLLOW $accesscode_ok
        $autoparagraph $blog $DEBUG %failed_leaves 
        $mci_fillin_func $preview
        %runtime_mcis
        %template
        %user_input $version
        );

my @syll1 = qw(   qu l  z  m  p  v  g  t  s  n  x  b  k  d  w  f);
my @syll2 = qw(   a  e  i  o  u  ai ee ei ou ar er or oi y  yo ya);
                # 0  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f

$version = '1.0.1';
my (%default_template, %leaf_results, @months);

@months=('January','February','March','April','May','June',
  'July','August','September','October','November','December');

$default_template{'entryadded'} = 
'<html><head><title>Addendat: Entry added</title></head>
<body bgcolor="#000000" text="#00ff00" link="#00ffcc" vlink="#00cc66"
alink="#ffffff">
<p>Entry added to <a href="%blogurl%">%blogurl%</a>.</p>
<p>Publicization: <pre><b>
%response%
%leaf_results%
</b></pre>
</p>
</body></html>';

$default_template{'entrylistitem'} = '<p>Entry %entryid%: <a href="%cgiurl%?action=edit;entryid=%entryid%;blog=%blog%">edit</a>, <a href="%cgiurl%?action=delete;entryid=%entryid%;blog=%blog%">delete</a>.</p><blockquote>%entry%</blockquote>';


sub read_default_config_file()
{
#  if (!defined($configfile)) {
#    $configfile = "$libdir/addendat.cfg";
#  }
#  return &read_config_file($configfile);
  return &read_config_file("$main::libdir/addendat.cfg");
}

sub read_config_file($)
{
  my $configfile = $_[0];
  local *CFG;
  my $file;
  my $tag;
  my %template;
  open(CFG,"<$configfile") || &UI::fatalerror("Cannot open $configfile.");
  local $/;
  $file=<CFG>;
  close(CFG);
  while ($file=~/\<%(.*?)%\>(.*?)\<\/%(.*?)%\>/s) {
    $tag=$1;
    if ($file=~/\<%\Q$tag\E%\>(.*?)\<\/%\Q$tag\E%\>/s) {
      &UI::fatalerror("Duplicate definition of &lt;\%$tag\%&gt;") if (exists($template{$tag}));
      $template{$tag}=$1;
      $file=~s/\<%\Q$tag\E%\>(.*?)\<\/%\Q$tag\E%\>//s;
    } else {
      &UI::fatalerror("Malformed pseudotag $tag");
    }
  }
  return %template;
}

sub init_runtime_mcis()
{
  my @date=localtime(time);
  $date[5]+=1900;
  $runtime_mcis{minutes}=$date[1];
  $runtime_mcis{hour}=$date[2];
  $runtime_mcis{year}=$date[5];
  $runtime_mcis{hexyear}=sprintf("0x%X",$date[5]);
  $runtime_mcis{month}=$months[$date[4]];
  $runtime_mcis{monthnum}=$date[4]+1;
  $runtime_mcis{day}=$date[3];
  $runtime_mcis{hexday}=sprintf("0x%X",$date[3]);
}

my $ENTRY_FILE_MCIS_SET = 0;

my %entry_file_mcis = ('entrynum' => undef, 'hexentrynum' => undef, 'entryid' => undef);

sub init_entry_file_mcis()
{
  return if $ENTRY_FILE_MCIS_SET;
  if (exists($template{entryidpath})) {
    my $entrynum=0;
    my $notdone=1;
    while ($notdone) {
      $runtime_mcis{entrynum}=$entrynum;
      $runtime_mcis{hexentrynum}=sprintf("0x%X",$entrynum);
      $runtime_mcis{entryid}=&expand_mcis($template{entryidformat});
      local *ENTRY;
      my $entryfile=&expand_mcis($template{entryidpath});
      system("echo $entryfile >/dev/null");
      if (sysopen(ENTRY, "$entryfile", &Fcntl::O_RDONLY|&Fcntl::O_CREAT|$O_NOFOLLOW|&Fcntl::O_EXCL)) {
        # Only try to chmod the file if you're running as a UID who should.
        if (exists($template{chmodusers}) && (getpwuid($<)=~/$template{chmodusers}/s)) {
          # Sanitize mode to ensure that config files don't make suid
          # or executable bloglets.
          if (!chmod(oct($template{newfilemode}) & 0666, $entryfile)) {
            &UI::fatalerror("Could not chmod the new file sanely.");
          }
        }
        close(ENTRY);
        $notdone=0;
      }
      $entrynum++;
      if ($entrynum>500) {
        &UI::fatalerror("Error: More than 500 blog entries today,
or runaway loop of some sort...  Addition to $blog cancelled.
If you need more than 500 blog entries a day, edit Addendat.pm,
find this message, and change the \$entrynum>500 before it to something
that you like better.  \%blogfile\% was '".&expand_mcis('%blogfile%').
"'\n\$entryfile was $entryfile.
This error may also occur if you can't write to the comments dir.\n");
      }
    }
  }
  $ENTRY_FILE_MCIS_SET = 1;
}

sub init()
{
  my $template = tie (%template, 'DefaultedHash', %default_template,
    &read_default_config_file());
  if (exists($template{'includefile'})) {
    if (-r $template{'includefile'}) {
      my %cfg = &read_config_file($template{'includefile'});
      my $k;
      for $k (keys(%cfg)) {
        $template{$k} = $cfg{$k};
      }
      # %template = (%template, &read_config_file($template{'includefile'}));
    }
  }
  $template->set_path(\$blog);
  &determine_O_NOFOLLOW();
  &init_runtime_mcis();
  return $template;
}

sub trim_entries_characters()
{
  my $entry;
  my $len=0;
  my $maxlen=shift;
  foreach $entry (@_) {
    $len+=length($$entry[1]);
  }
  if ($template{add} eq 'top') {
    while ($len>$maxlen and @_) {
      if (!@_) {
        &UI::fatalerror("Tried to remove all entries.");
      }
      $len-=length(${$_[$#_]}[1]);
      if ($len>$maxlen) {
        pop(@_);
      }
    }
  } elsif ($template{add} eq 'bottom') {
    while ($len>$maxlen and @_) {
      if (!@_) {
        &UI::fatalerror("Tried to remove all entries.");
      }
      $len-=length(${$_[0]}[1]);
      if ($len>$maxlen) {
        shift(@_);
      }
    }
  } else {
    &UI::fatalerror("%add% must be top or bottom.");
  }
  return @_;
}

sub trim_entries()
{
  my $maxlen=$template{'length'};
  if ((!defined($maxlen)) || ($maxlen eq '')) {
    return @_;
  }
  my $numlen;
  if ($maxlen=~/^([0-9]+)/) {
    $numlen=$1;
  } else {
    return @_;
  }
  $maxlen=~s/$numlen //s;
  if ($maxlen eq 'characters') {
    return &trim_entries_characters($numlen,@_);
  } else {
    &UI::fatalerror("Invalid entry list trim type: '$template{length}'");
  }
}

sub slurp_define()
{
  local *INCLUDE;
  local $/="\n";
  if (open(INCLUDE,"<$_[1]")) {
    my @include=<INCLUDE>;
    @include=grep{/^#[ \t]*define(.*?)\Q$_[0]\E(.*?)([0-9x]+)/} @include;
    if (!@include) {
      return undef;
    }
    if ($include[0]=~/^#[ \t]*define(.*?)\Q$_[0]\E(.*?)([0-9x]+)/) {
      my $val=$3;
      if ($val=~/^0/) {
        return oct($val);
      } else {
        return $val;
      }
      return undef;
    }
  }
  return undef;
}

sub determine_O_NOFOLLOW()
{
  if (defined(&O_NOFOLLOW)) {
    $O_NOFOLLOW=&O_NOFOLLOW;
  } else {
    my $uname = `uname`;
    if (($uname=~/Solaris/) || ($uname=~/^SunOS/)) {
      #  Apparently opening a symlink to nowhere O_CREAT|O_EXCL on
			#  SunOS and Solaris fails, making O_NOFOLLOW unnecessary.
			#  Which is good, as it doesn't exist on SunOS/Solaris.
      $O_NOFOLLOW=0;
	  } else {
      $O_NOFOLLOW=(&slurp_define('O_NOFOLLOW','/usr/include/asm/fcntl.h') ||
        &slurp_define('O_NOFOLLOW','/usr/include/fcntl.h') ||
        &slurp_define('O_NOFOLLOW','/usr/include/bits/fcntl.h'));
    }
  }
  if (!defined($O_NOFOLLOW)) {
    my $uname = `uname -a`;
    if ($uname=~/^Linux (.*?)i[3456]86/s) {
      $O_NOFOLLOW = 0400000;
    } else {
      &UI::fatalerror("Cannot figure out the correct value for O_NOFOLLOW.\n
        This is probably a bug; contact the author (Deekoo\@tentacle.net)\n");
    }
  }
}
=head2
sub decompose_xml($)
{
  my @ret = ();
  my $in = $_[0];
  while (length($in)) {
    if ($in=~s/^([^<]+)//s) {
      push @ret, {str=>$1};
    } elsif ($in=~s/^<([a-zA-Z0-9]+)//s) {
      my %tag = ( tag => $1, str => $1 );
      push @ret, \%tag;
      my $intag = 1;
      while ($intag and length $in) {
        if ($intag==1) {
          if ($in=~s/^([\s]+)//s) {
            $tag{str} .= $1;
          } elsif ($in=~s/^\/>//s) {
            $tag{str} .= '/>';
            $intag = 0;
          } else {
            $tag{str} .= substr($intag,0,1);
          }
        } else {
          ...
        }
      }
    }
  }
}
=cut

sub apply_linkprefix($)
{
  my $in = $_[0];
  # What we want is to get all the URLs that don't match
  # /^[a-z0-9]+:/ and apply the linkprefix to them.  So
  # ([^a-z0-9]|[a-z0-9]+[^:])?
  my $localurlre = '[^a-z0-9]|[a-z0-9]+[^a-z0-9:]';
  my $ret = '';
  while (length($in)) {
    if ($in=~s/^([^<]+)//s) {
      $ret .= $1;
    # Todo - these really should be handled more dynamically, so URIiferous
    # tags'll be easier to add.
    } elsif ($in=~s/^\<a([^\>]+?)href=\"($localurlre[^"]*)\"//s) {
      $ret .= "<a$1href=\"$template{linkprefix}$2\"";
    } elsif ($in=~s/^\<img([^\>]+?)src=\"($localurlre[^"]*)\"//s) {
      $ret .= "<img$1src=\"$template{linkprefix}$2\"";
    } elsif ($in=~s/^\<td([^\>]+?)background=\"($localurlre[^"]*)\"//s) {
      $ret .= "<td$1background=\"$template{linkprefix}$2\"";
    } else {
      $in=~s/^(.[^<]+)//s;
      $ret .= $1;
    }
  }
  return $ret;
}

sub expand_mcis($)
{
        # args: 0: Text.
        my $in = $_[0];
        my $out = '';
        my $uri_escape = 0;
        my $mci;
        my $orig;
        while (length($in)) {
                if ($in=~/^([^%]+)/s) {
                        $out .= $1;
                        substr($in,0,length($1)) = '';
                } elsif ($in=~/^%([\(\)_a-z]+)%/s) {
                        $orig=$mci=$1;
                        substr($in,0,length($mci)+2) = '';
                        if ($mci=~/^urlescape\(([_a-z]+)\)$/s) {
                                $uri_escape = 1;
                                $mci = $1;
                        } elsif ($mci=~/^ifdef\(([_a-z]+)\)$/s) {
                                $mci = $1;
                                if (exists($user_input{$mci})) {
                                        $in =~ s/\%endif\(\Q$mci\E\)\%//s;
                                } else {
                                        $in =~ s/^(.*?)\%endif\(\Q$mci\E\)\%//s;
                                }
                                next;
                        } elsif ($mci=~/^iflen\(([_a-z]+)\)$/s) {
                                $mci = $1;
                                if (exists($user_input{$mci}) && ($user_input{$mci} ne '') or (exists($runtime_mcis{$mci}) && length $runtime_mcis{$mci})) {
                                        $in =~ s/\%endif\(\Q$mci\E\)\%//s;
                                } else {
                                        $in =~ s/^(.*?)\%endif\(\Q$mci\E\)\%//s;
                                }
                                next;
                        } elsif ($mci=~/^rawinput\(([_a-z]+)\)$/s) {
                                $mci = $1;
                                if (exists($user_input{$mci}) && defined($user_input{$mci})) {
                                        $out .= $user_input{$mci};
                                }
                                next;
                        }
                        my $param=$user_input{$mci};
                        if (defined($param)) {
                                if ($autoparagraph) {
                                        $param =~ s/\015\012\015\012/\<p\>/sg;
                                }
                                if ($DEBUG) {
                                        print STDERR "$mci found as CGI parameter ($param)\n";
                                }
                        } elsif (exists($template{$mci})) {
                                $param = &expand_mcis($template{$mci});
                                # Check to make sure this doesn't recurse dangerously.
                        } elsif (exists($runtime_mcis{$mci})) {
                                $param = $runtime_mcis{$mci};
                                #      $text=~s/%$mci%/$runtime_mcis{$mci}/gs;
                        } elsif (exists($entry_file_mcis{$mci})) {
                                &init_entry_file_mcis();
                                if (exists($runtime_mcis{$mci})) {
                                        $param = $runtime_mcis{$mci};
                                } else {
                                        &UI::fatalerror("Failed to initialize runtime \%-code $mci".($mci eq 'entryid' ? "  Probably your template isn't correctly setting entryidpath." : ''));
                                }
                        } else {
                                # No longer setting user_input to static %$mci%
                                # This might break something else, but appears
                                # to fix a spamfilter problem.
                                if ($mci_fillin_func) {
                                  $param = &{$mci_fillin_func}($mci);
#                                  $param = $user_input{$mci} = &{$mci_fillin_func}($mci);
                                } else {
                                  $param = '%'.$mci.'%';
#                                  $param = $user_input{$mci} = '%'.$mci.'%';
                                }
                        }
                        if ($uri_escape) {
                                if (exists($template{linkprefix})) {
                                        $param = &apply_linkprefix($param);
                                }
                                $param = urlescape($param);
#                                eval('$param = uri_escape($param);');
                                $uri_escape = 0;
                        }
                        $out .= $param;
                } else {
                        $out .= substr($in,0,1);
                        substr($in,0,1) = '';
                }
        }
        if (exists($template{linkprefix})) {
                $out = &apply_linkprefix($out);
        }
        return $out;
}

sub open_html_file()
{
#  local *FILE;
  local $/;
  my $err=1;
  my $filename=&expand_mcis($template{blogfile});
  if ($filename=~/^([-\/a-zA-Z.0-9_~]+)$/s) {
    if ($filename=~/\.\./s) {
      &UI::fatalerror("'..' found in blog filename '$filename'.  Aborting.");
    }
    $filename=$1;
  } else {
    if ((!defined($filename)) || ($filename eq '')) {
      &UI::fatalerror("No blog file specified.  Your config file is either incomplete
or misformatted.  Check to make sure you're not trying to use a UTF-16/UCS-2 or
EBCDIC config file on an ASCII or UTF-8 system.  Some Windows editors like UCS-2.");
    }
    &UI::fatalerror("Invalid characters in filename '$filename'.  Supported characters\n
are -, /, a-z, A-Z, 0-9, ., _, and ~.  If you think the character you wanted\n
to use that's not in this set should be considered safe, please email a bug\n
report to deekoo\@tentacle.net.\n"); 
  }
  my $header;
  my $footer;
  if (sysopen(FILE,$filename,&Fcntl::O_RDWR|$O_NOFOLLOW) ||
    (exists($template{blankfile}) and length($template{blankfile})
    && sysopen(FILE,$filename, &Fcntl::O_RDWR|$O_NOFOLLOW|&Fcntl::O_CREAT|&Fcntl::O_EXCL))) {
    if (flock(FILE,&Fcntl::LOCK_EX)) {
      if (seek(FILE,0,&Fcntl::SEEK_END)) {
        if (tell(FILE)==0) {
          if (print FILE &expand_mcis($template{blankfile})) {
            if (seek(FILE,0,&Fcntl::SEEK_SET)) {
              $err=0;
            } else {
              &UI::fatalerror("seek($filename,0,&SEEK_SET) failed.");
            }
          } else {
            &UI::fatalerror("Unable to initialize blank file.");
          }
	} else {
	  # File isn't blank.
          if (seek(FILE,0,&Fcntl::SEEK_SET)) {
            $err=0;
          } else {
            &UI::fatalerror("seek($filename,0,&SEEK_SET) failed.");
          }
	}
      } else {
        &UI::fatalerror("Seek error.");
      }
    } else {
      &UI::fatalerror("Cannot lock $filename");
    }
  } else {
    &UI::fatalerror("Unable to open '$filename'.");
  }
  if ($err) {
    &UI::fatalerror("Cannot open ".&expand_mcis($template{blogfile}));
  }
  my $file=<FILE>;
#  close(FILE);
  my @entries=();
  if ($file=~/^(.*?)\<!-- Entry \(\Q$blog\E\) \[(.*?)\] --\>(.*)\<!-- \/Entry \(\Q$blog\E\) \[(.*?)\] --\>(.*?)$/s) {
    $header = $1;
    $footer = $5;
    while ($file=~s/\<!-- Entry \(\Q$blog\E\) \[(.*?)\] --\>(.*?)\<!-- \/Entry \(\Q$blog\E\) \[(.*?)\] --\>//s) {
      push(@entries,[$1,$2]);
    }
  } elsif ($file=~/^(.*?)\<!-- Entry \(\Q$blog\E\) --\>(.*)\<!-- \/Entry \($blog\) --\>(.*?)$/s) {
    $header=$1;
    $footer=$3;
    while ($file=~/\<!-- Entry \($blog\) --\>(.*?)\<!-- \/Entry \($blog\) --\>/s) {
      push @entries,[undef,$1];
      $file=~s/\<!-- Entry \($blog\) --\>(.*?)\<!-- \/Entry \($blog\) --\>//s;
    }
  } elsif ($file=~/^(.*?)\<!-- Add Here \($blog\) --\>(.*?)$/s) {
    $header=$1;
    $footer=$2;
  } elsif ($file=~/^(.*?)\<!-- Entry --\>(.*)\<!-- \/Entry --\>(.*?)$/s) {
    $header=$1;
    $footer=$3;
    while ($file=~/\<!-- Entry --\>(.*?)\<!-- \/Entry --\>/s) {
      push @entries,[undef,$1];
      $file=~s/\<!-- Entry --\>(.*?)\<!-- \/Entry --\>//s;
    }
  } elsif ($file=~/^(.*?)\<!-- Add Here --\>(.*?)$/s) {
    $header=$1;
    $footer=$2;
  } else {
    $failed_leaves{$blog} =
      "Unable to find blog entries or 'Add Here' comment.  Cannot add.\nBlog is '$blog'; filename is $filename.\n";
    return 0;
  }
  # Note: If you want whitespace below the last entry, do not use literal
  # newlines if you've got the whole page wrapped in a pre/xmp.  Rather,
  # close your pre/xmp and start a new one.
  $footer=~s/^[\n\r]//gms;
  return ($header, @entries, $footer);
#  return 1;
}

sub note_total($$)
{
  my $oldblog = $blog;
  $blog = $_[0];
  my $file = &expand_mcis($template{blogfile});
  $blog = $oldblog;
  local *FILE;
  if (!open(FILE,"+<$file")) {
    $leaf_results{$blog} .= "Nonfatal error: Could not update entry count.\n";
    return;
  }
  if (flock(FILE,&Fcntl::LOCK_EX)) {
    local $/;
    my $file = <FILE>;
    if (defined($file)) {
      if (seek(FILE,0,&Fcntl::SEEK_SET)) {
        if ($file=~/\<\!-- Total \(\Q$blog\E\) --\>([0-9a-fA-FxX]+)\<\!-- \/Total \(\Q$blog\E\) --\>/s) {
          my $num = $1;
          my $newnum = $_[1];
          if ($num=~/x/i) {
            $newnum = sprintf('0x%X', $newnum);
          }
          $file=~s/\<\!-- Total \(\Q$blog\E\) --\>([0-9a-fA-FxX]+)\<\!-- \/Total \(\Q$blog\E\) --\>/<!-- Total ($blog) -->$newnum<!-- \/Total ($blog) -->/gs;
          if (print FILE $file) {
            truncate(FILE,tell(FILE));
            close(FILE);
#            print STDERR "Successful total update.\n";
            return;
          } else {
            print STDERR "File print file fail.\n";
          }
        } else {
          print STDERR "Unable to find place to put comment count.\n";
        }
      } else {
        print STDERR "Seek0 failed.\n";
      }
    } else {
      print STDERR "deffail\n";
    }
  } else {
    print STDERR "Flock fail.\n";
  }
  print STDERR "Failed total update ($file;$blog;@_)\n";
  close(FILE);
}

sub propagate_entry_http()
{
        my $blogfile=&expand_mcis($template{blogfile});
        if ($blogfile!~/^(http(|s)):(.*?)$/) {
                &UI::fatalerror("Invalid http(s) URL syntax in $blogfile\n");
        }
	if (!eval("use LWP::UserAgent; 1;")) {
		$failed_leaves{$blog}="Propagation of blog entry to remote CGI $blogfile failed because LWP::UserAgent is not installed on your server.\n";
		return;
	}
	my $ua = new LWP::UserAgent;
	$ua->agent("Addendat/$Addendat::version");
	my $req = new HTTP::Request( POST => $blogfile );
	$req->content_type('application/x-www-form-urlencoded');
	$req->content(&expand_mcis($template{entry}));
	my $res=$ua->request($req);
	if ($res->is_success) {
	  # Handle success
	} else {
		$failed_leaves{$blog} = "Post of $blogfile failed.";
	}
	return;
}

sub propagate_entry_lj()
{
  my $blogfile = &expand_mcis($template{blogfile});
  if ($blogfile!~/^lj:(.*?)$/) {
    $failed_leaves{$blog}="Invalid LiveJournal URL syntax in $blogfile\n";
    return;
  }
  $blogfile=~s/^lj:/http:/;
  if (!eval('use LWP::UserAgent; 1;')) {
    $failed_leaves{$blog}="Propagation of blog entry to LiveJournal URL $blogfile failed because LWP::UserAgent is not installed on your server.\n";
    return;
  }
  my $ua = new LWP::UserAgent;
  $ua->agent("Addendat/$Addendat::version");
  my $req = new HTTP::Request('POST' => $blogfile);
  $req->content_type('text/plain'); # &expand_mcis($template{entry}));
  my $ent = &expand_mcis($template{entry});
  $req->content(&expand_mcis($template{entry}));
  my $res = $ua->request($req);
  if ($res->is_success) {
    my @ljres = split(/\012/s, $res->content);
    $leaf_results{$blog} = 'LiveJournal Output:';
    my $ljres;
    while (@ljres) {
      $ljres = shift(@ljres);
      $ljres = 'undef' if !defined($ljres);
      $leaf_results{$blog} .= $ljres;
      $ljres = shift(@ljres);
      $ljres = 'undef' if !defined($ljres);
      $leaf_results{$blog} .= ": ".$ljres."\n";
    }
    # XXX HANDLE OUTPUT.
  } else {
    $failed_leaves{$blog} = "Error sending HTTP request to LiveJournal server. ($!)\n";
  }
  return;
}

sub save_html_file(@)
{
  my $html = shift(@_);
  my $footer = pop(@_);
  my $item;
  if ($item=shift(@_)) {
    $html.="<!-- Entry ($blog) [$$item[0]] -->$$item[1]<!-- /Entry ($blog) [$$item[0]] -->\n";
    foreach $item (@_) {
      $html.=expand_mcis($template{entryseparator});
      $html.="<!-- Entry ($blog) [$$item[0]] -->$$item[1]<!-- /Entry ($blog) [$$item[0]] -->\n";
    }
  } else {
    $html.="<!-- Add Here ($blog) -->\n";
  }
  $html.=$footer;
  seek(FILE,0,&Fcntl::SEEK_SET);
  print FILE $html;
  my $htmllen=length($html);
  if ($htmllen=~/([0-9]+)/) {
    $htmllen=$1;
  } else {
    &UI::fatalerror("Cannot untaint '$htmllen'.  Should be a number.\n");
  }
  truncate(FILE,$htmllen);
  flock(FILE,&Fcntl::LOCK_UN);
  close(FILE);
}

sub note_totals($)
{
  my $num = $_[0];
  if ($template{totalinblogs} eq '') {
    &note_total('',$num);
  } else {
    my @blogs = split(/,/,$template{totalinblogs});
    my $b;
    for $b (@blogs) {
      &note_total($b,$num);
    }
  }
}

sub add_entry_to_leaf()
{
  my $oldblog=$blog;
  $blog=$_[0];
  if ($DEBUG) {
    print STDERR "Adding entry to leaf '$blog'\n";
  }
  if ($template{blogfile} =~ /^http(s|):/) {
    &propagate_entry_http();
    return;
  } elsif ($template{blogfile} =~ /^lj:/) {
    &propagate_entry_lj();
    return;
  } else {
    my @entries = &open_html_file();
    if (!@entries) {
      print STDERR "Error opening HTML file for $blog.\n";
      # Does the error need to be described here?  XXX
      return;
    }
    my $footer = pop @entries;
    my $html = shift @entries;
    if ($template{add} eq 'top') {
      @entries=&trim_entries(@entries);
      unshift(@entries,[&expand_mcis('%entryid%'),&expand_mcis($template{entry})]);
    } elsif ($template{add} eq 'bottom') {
      @entries=&trim_entries(@entries);
      push(@entries,[&expand_mcis('%entryid%'),&expand_mcis($template{entry})]);
    } else {
      &UI::fatalerror('$template{add} is '."'$template{add}'.
        Only 'top' and 'bottom' are understood by the current version of
        Addendat.");
    }
#    $html=$header;
    save_html_file($html, @entries, $footer);
    if (exists($template{totalinblogs})) {
      &note_totals($#entries+1);
    }
  }
  $blog=$oldblog;
}

sub urlescape()
{
  my $url=$_[0];
  my $ret;
  my $x=0;
  my $c;
  my $n;
  while ($x<length($url)) {
    $c=substr($url,$x,1);
    if ($c=~/^[a-zA-Z\/]$/) {
      $ret.=$c;
    } elsif ($c eq ' ') {
      $ret.='+';
    } else {
      $ret .= '%'.sprintf("%02X",ord($c));
    }
    $x++;
  }
  return $ret;
}

sub publicize()
{
  my $response;
  if (eval("use LWP::UserAgent; 1;")) {
    my $req = HTTP::Request->new('GET', 
      'http://'.$template{hubmachine}.$template{hubscript}.
			  '?url='.&urlescape($template{blogurl}).'&blog='.
				&urlescape($template{blogtitle}));
    my $ua = new LWP::UserAgent;
    $response = $ua->request($req);
    if ($response->is_success) {
		  $response=$response->content;
    } else {
		  $response="Publicization failed.\n";
		}
	} else {
    $response="Publicization failed: LWP::UserAgent not installed.\n";
	}
  $runtime_mcis{response}=$response;
}

=head2 test_html_nesting($string)

  Return 1 if all tags in $string are closed (or don't require closure), 0
  otherwise.

=cut

sub test_html_nesting($)
{
  # XXX FNORD!
}

=head2 Addendat::test_nesting()

  Test HTML nesting of fields with test_nesting:$field set.

=cut

sub test_nesting()
{
  for my $key (keys(%user_input)) {
    if (exists($template{"test_nesting:$key"})) {
      return 0 unless test_html_nesting($user_input{$key});
    }
  }
  return 1;
}

sub store_entry_in_file($)
{
  my $f = $_[0];
  local *F;
  my $dbent = '';
  for my $param (keys(%user_input)) {
    &UI::fatalerror("User input field $param contains the string &lt;%.  This is used in Addendat configuration language and is almost certain to screw up loading this post from the DB.  Post not saved.\n") if $user_input{$param}=~/\<\%/s;
    $dbent .= "<\%$param(u)\%>".$user_input{$param}."</\%$param(u)\%>\n";
  }
  if (!sysopen(F,$f,&Fcntl::O_WRONLY|$O_NOFOLLOW|&Fcntl::O_CREAT|&Fcntl::O_TRUNC)) {
    print STDERR "Error $! opening $f.\n";
    &UI::fatalerror("Error $! opening database entry file $f.");
  }
  binmode(F);
  my $oldentryid = $runtime_mcis{entryid};
  delete $runtime_mcis{entryid};
  for my $mci (keys(%runtime_mcis)) {
    if (!defined($runtime_mcis{$mci})) {
      print STDERR "runtime_mcis($mci) undef.\n";
    }
    $dbent .= "<\%$mci(r)\%>$runtime_mcis{$mci}</\%$mci(r)%>\n";
  }
  $runtime_mcis{entryid} = $oldentryid if defined $oldentryid;
  flock(F,&Fcntl::LOCK_EX) or &UI::fatalerror("Error locking database file.\n");
  print F $dbent;
  close(F) or &UI::fatalerror("Error closing database entry.");
}

sub clean_old_tempdir_entries()
{
  # Deletes all tempdir entries >30 days old.
  local *DIR;
  opendir(DIR,$template{turing_dbdir});
  my @dir = readdir(DIR);
  closedir(DIR);
  my $f;
  for $f (@dir) {
    if (-f "$template{turing_dbdir}/$f" and 
      ((-M "$template{turing_dbdir}/$f")>30) and 
      "$template{turing_dbdir}/$f"=~/^(.*?)$/s) {
      unlink($1);
    }
  }
}

sub store_entry_in_turing_db()
{
  if (!defined($template{turing_dbdir})) {
    &UI::fatalerror("Error: no turing-check data storage directory.");
  } elsif (!defined($runtime_mcis{entryid})) {
    init_entry_file_mcis();
    if (!defined($runtime_mcis{entryid})) {
      &UI::fatalerror("Error: no entryid set.\n");
    }
  }
  &clean_old_tempdir_entries();
  store_entry_in_file("$template{turing_dbdir}/$runtime_mcis{entryid}");
}

sub handle_turing_match()
{
  store_entry_in_turing_db();
  print "Content-type: text/html\015\012\015\012";
  print &expand_mcis($template{turing_filtered});
  exit(0);
}

=head2 Addendat::do_preview($blog, $publicize)
=cut
sub do_preview($;$)
{
  if (exists $template{dbdir}) {
    if (!defined($runtime_mcis{"randfile"})) {
      my $r = int(rand(65536));
      $runtime_mcis{"randfile"} = $syll1[($r>>12)&0xf].$syll2[($r>>8)&0xf].
        $syll1[($r>>4)&0xf].$syll2[$r&0xf];
    }
    store_entry_in_file("$template{turing_dbdir}/$runtime_mcis{randfile}") 
  }
  &UI::fatalerror("Cannot preview entry - preview form is not defined.\n")
    unless defined $template{previewform};
  print "Content-type: text/html\015\012\015\012";
  print &expand_mcis($template{previewform});
  print "\n";
  exit(0);
}

sub check_lastentry()
{
  my $lastentry = $template{dbdir}."/_last_.$>";
  if (-f $lastentry) {
    if (!-r $lastentry) {
      unlink($lastentry);
    } else {
      my %uent = %user_input;
      my %dbent = read_config_file($lastentry);
      for my $k (keys(%dbent)) {
        if ($k=~/\(u\)$/s) {
          $k = substr($k,0,-3);
          last unless exists $uent{$k};
          last if ($uent{$k} ne $dbent{"$k(u)"});
          delete $uent{$k};
          delete $dbent{"$k(u)"};
        }
      }
      if (!keys(%uent)) {
        &UI::fatalerror("Error: this blog entry or comment has already been posted.  If it didn't show up, make sure you reload the page.");
      }
    }
  }
}

=head2 Addendat::add_entry($blog, $publicize)

  Add an entry to blog $blog.  If $publicize is true, publicize the addition
  on the hub.
  
=cut

sub add_entry($;$)
{
  check_lastentry();
  if (exists($template{turing_filterregex})) {
    for my $p (values(%user_input)) {
      if ($p=~/($template{turing_filterregex})/six) {
        $runtime_mcis{turing_match} = $1;
        &handle_turing_match();
      }
    }
  }
  &post_entry(@_);
}

my %runtime_mci_sanitychecks = (
        day     => '^([0-9]+)$',
        entrynum=> '^([0-9]+)$',
        month   => '^([A-Z][a-z]+)$',
        year    => '^([0-9]+)$',
        );

sub sanitycheck_runtime($$)
{
  my ($key,$dat) = @_;
  if (exists($runtime_mci_sanitychecks{$key})) {
    my $re = $runtime_mci_sanitychecks{$key};
    if ($dat=~/$re/s) {
      print STDERR "$key=$1\n";
      return $1;
    } else {
      &UI::fatalerror("Bad value for runtime MCI $key: $dat.\n");
    }
  }
  return $dat;
}

my %safe_usersettable_runtime_mcis = ( 
        # The list of runtime MCIs that may be safely set in a stored file.
        # All others will not be loaded.
        turing_match => 1,
        );

sub slurp_stored_input($$)
{
  local *F;
  if ($_[1]!~/^([-0-9A-Z_a-z]+)$/s) {
    &UI::fatalerror("Invalid characters in entry ID.\n");
  }
  my $fn = $1;
  my %dbent = &read_config_file("$_[0]/$fn");
  my %new_runtime_mcis;
  my %new_user_input;
  for my $k (keys(%dbent)) {
    my $mci = substr($k,0,-3);
    if ($k=~/\(r\)$/s) {
      $new_runtime_mcis{$mci} = sanitycheck_runtime($k,$dbent{$k})
        if $safe_usersettable_runtime_mcis{$mci};
    } elsif ($k =~/\(u\)$/s) {
      $new_user_input{$mci} = $dbent{$k};
    } else {
      &UI::fatalerror("Error: Unexpected field $k.\n");
    }
  }
  delete $new_runtime_mcis{entryid};
  # XXX in future, will have hooks for specifying which of multiple Turing
  # test answers / confirmations to use.  Which is why we check regex *here*.
  if (exists($new_runtime_mcis{turing_match}) and $user_input{turing_response}!~/$template{turing_responseregex}/six) {
    &UI::fatalerror("Invalid response.  If you are a sentient being, hit back and try again.");
  }
  %runtime_mcis = (%runtime_mcis,%new_runtime_mcis);
  my $resp = $user_input{turing_response};
  %user_input = %new_user_input;
  $user_input{turing_response} = $resp if defined $resp;
  $blog = $user_input{'blog'};
  $blog = '' unless defined $blog;
}

sub propagate_stored_entry($)
{
  if ($preview) {
    do_preview(@_);
  }
  # Note - assuming 'publicize' is 0.
  if (exists($user_input{'entryid'})) {
    &slurp_stored_input($template{turing_dbdir},$user_input{'entryid'});
    if (!$accesscode_ok) {
      my $uacccode = $user_input{accesscode} if exists $user_input{accesscode};
      $uacccode = '' unless defined $uacccode;
      if ($uacccode ne $template{accesscode}) {
        &UI::fatalerror("Access code mismatch trying to propagate stored entry.\n");
      }
    }
    &post_entry($blog,$user_input{'publicize'});
  } else {
    &UI::fatalerror("Propagate WHAT?");
  }
}

sub post_entry($;$)
{
  check_lastentry();
  if ($preview) {
    do_preview(@_);
  }
  my ($blog, $publicize) = @_;
  if ($DEBUG) {
    print STDERR "Adding entry to '$blog'\n.";
  }
  if (exists $template{dbdir}) {
    init_entry_file_mcis() unless defined $runtime_mcis{entryid};
    store_entry_in_file("$template{dbdir}/$runtime_mcis{entryid}") 
  }
  &add_entry_to_leaf($blog);
  if (%failed_leaves) {
    &main::show_failed(1);
  }
  # This may move into add_entry_to_leaf() sometime, thus allowing leaves
  # to have leaves.
  if (exists($template{leaves})) {
    my $leaf;
    if ($DEBUG) {
      print STDERR "Leaves found.\n.";
    }
    my @leaves=split(/,/,$template{leaves});
    foreach $leaf (@leaves) {
      &add_entry_to_leaf($leaf);
    }
  }
  if (%failed_leaves) {
    &main::show_failed(0);
  }
  if ($DEBUG) {
    print STDERR "Publicizing.\n";
  }
  if ($publicize) {
    &publicize();
  } else {
    $runtime_mcis{response}='[Publicization not relevant]';
  }
  $runtime_mcis{leaf_results} = '';
  if (%leaf_results) {
    my @keys = keys(%leaf_results);
    my $k;
    for $k (@keys) {
      $runtime_mcis{leaf_results} .= "Leaf '$k':\n$leaf_results{$k}\n";
    }
  }
  store_entry_in_file("$template{dbdir}/_last_.$>");
  &UI::show_entryadded();
}

sub set_cfg_item($$$)
{
  my ($file,$var,$val) = @_;
  local *F;
  local $/;
  open(F,"<$_[0]") or return undef;
  binmode(F);
  my $f = <F>;
  my $mode = (stat(F))[2] & (&Fcntl::S_IRWXU|&Fcntl::S_IRWXG|&Fcntl::S_IRWXO);
  close(F);
  my $oldf = $f;
  if (!($f =~ s/<%\Q$var\E%>.*?<\/%\Q$var\E%>/<%$var%>$val<\/%$var%>/s)) {
    $f .= "\n<%$var%>$val</%$var%>\n";
  }
  if ($f eq $oldf) {
    return 1;
  }
  open(F,">$_[0].new") or return undef;
  print F $f or return undef;
  close(F);
  if (-s "$_[0].new" == length($f)) {
    # XXX need to set mode properly, too.
    return chmod($mode,"$_[0].new") && rename("$_[0].new",$_[0]);
  }
  return undef;
}

sub delete_cfg_item($$)
{
  my ($file, $var) = @_;
  local *F;
  local $/;
  open(F,"<$file") or return undef;
  binmode(F);
  my $f = <F>;
  my $mode = (stat(F))[2] & (&Fcntl::S_IRWXU|&Fcntl::S_IRWXG|&Fcntl::S_IRWXO);
  close(F);
  if ($f=~s/<%\Q$var\E%>.*?<\/%\Q$var\E%>//s) {
    open(F,">$file.new") or return undef;
    print F $f or return undef;
    close(F);
    if (-s "$file.new" == length($f)) {
      return chmod($mode,"$file.new") && rename("$file.new",$file);
    }
    return 1;
  }
  return 1;
}

sub blogname($)
{
  if ((!defined($_[0])) or $_[0] eq '') {
    return "The default blog";
  } else {
    return "blog \'$_[0]\'";
  }
}

sub check_editaccesscode()
{
  if (defined($template{editaccesscode})) {
    if ($template{editaccesscode} ne $user_input{editaccesscode}) {
      &UI::fatalerror("Bad access code.");
      return;
    }
  } else {
    &UI::fatalerror("Editing entries in $Addendat::user_input{blog} has not been enabled by the blog's owner.  If you're the blog's owner, you will need to set a \%editaccesscode\% option in your config file before it will allow editing of posts; this is a security measure, as otherwise anyone who accidentally deleted the editaccesscode setting or who was upgrading from an older Addendat would wind up allowing anyone on the net to edit their entries, which I assume you don't want.");
    return;
  }
}

sub replace_entry()
{
  check_editaccesscode();
  $blog = $user_input{blog} = sanitize_blog($user_input{blog});
  $user_input{entryid} = sanitize_entryid($user_input{entryid});
#  slurp_stored_input();
  replace_in_leaf($blog);
  if (exists($template{leaves})) {
    if ($template{leaves} ne '') {
      my $leaf;
      my @leaves=split(/,/,$template{leaves});
      foreach $leaf (@leaves) {
        replace_in_leaf($leaf);
      }
    } else {
      replace_in_leaf('');
    }
  }
  store_entry_in_file("$template{dbdir}/$user_input{entryid}") 
  &UI::show_entryreplaced();
#  if (%failed_leaves) {
#    &main::show_failed(0);
#  }
}

sub count_entries($$)
{
  my $oldblog = $blog;
  my $newcount = 0;
  $blog = $_[0];
  local *HTML;
  local $user_input{'blog'} = $blog;
  my $file = &expand_mcis($template{'blogfile'});
  if (!open(HTML,"<$file")) {
    print STDERR "Error $! opening $file.\n";
    &UI::fatalerror("Error opening entry count.");
  }
  local $/;
  my $f = <HTML>;
  close(HTML);
  while ($f=~s/\<\!-- Entry \(\Q$blog\E\) \[(.*?)\] --\>(.*?)\<\!-- \/Entry \(\Q$blog\E\) \[(.*?)\] --\>//s) {
    $newcount++;
  }
  if ($_[1]=~/^0x/s) {
    $newcount = sprintf('0x%x',$newcount);
  }
  $blog = $oldblog;
  return $newcount;
}

sub replace_in_leaf($)
{
  my $oldblog = $blog;
  $blog = $_[0];
  if ($template{'blogfile'}=~/^[a-z]+:/s) {
    $failed_leaves{$blog} = "$blog: $template{blogfile} not editable.";
    return;
  }
  my @entries = open_html_file();
  my $replaced;
  if (@entries) {
    my $x = 1;
    while ($x<$#entries) {
      if (${$entries[$x]}[0] eq $user_input{'entryid'}) {
        ${$entries[$x]}[1] = &expand_mcis($template{'entry'});
        if (${$entries[$x]}[1]=~/<!-- Total \((.*?)\) -->([0-9x]+)<!-- \/Total \((.*?)\) -->/s) {
          my $blogname = $1;
          my $num = $2;
          my $count = &count_entries($blogname,$num);
          ${$entries[$x]}[1]=~s/<!-- Total \(\Q$blogname\E\) -->\Q$num\E<!-- \/Total \(\Q$blogname\E\) -->/<!-- Total ($blogname) -->$count<!-- \/Total ($blogname) -->/gs;
        }
        $replaced = 1;
        last;
      }
      $x++;
    }
    if ($replaced) {
      save_html_file(@entries);
    } else {
      &UI::fatalerror("Unable to find original entry to replace.");
    }
  } else {
    &UI::fatalerror("Error reading leaf.");
  }
  $blog = $oldblog;
}

sub sanitize_entryid($)
{
  if ($_[0]=~/^([-0-9A-Z_a-z]+)$/s) {
    return $1;
  } else {
    &UI::fatalerror("Dangerous entry ID.");
  }
}

sub sanitize_blog($)
{
  if ($_[0]!~/\.\./s && $_[0]=~/^([-\/0-9A-Z_a-z]+)$/s) {
    return $1;
  } elsif ($_[0] eq '') {
    return '';
  } else {
    &UI::fatalerror("Dangerous blog ID.");
  }
}

sub delete_entry($$)
{
  check_editaccesscode();
  $user_input{blog} = $blog = sanitize_blog($user_input{blog});
  $user_input{entryid} = sanitize_entryid($user_input{entryid});
  delete_in_leaf($blog);
  if (exists($template{leaves})) {
    if ($template{leaves} ne '') {
      my $leaf;
      my @leaves = split(/,/,$template{leaves});
      for $leaf (@leaves) {
        delete_in_leaf($leaf);
      }
    } else {
      delete_in_leaf('');
    }
  }
  if ($template{dbdir}=~/^(.*?)$/s) {
    my $oldname = "$template{dbdir}/$user_input{entryid}";
    rename($oldname,"$template{'dbdir'}/_last_erased_dbent.$>") or &UI::fatalerror("Error $! renaming old dbent.");
  }
#  print STDERR "Debug: wanted to erase DB entry ",&expand_mcis("$template{'dbdir'}/%entryid%"),"\n";
  &UI::show_entrydeleted();
}

sub delete_in_leaf($)
{
  my $oldblog = $blog;
  $blog = $_[0];
  if ($template{'blogfile'}=~/^[a-z]+:/s) {
    $failed_leaves{$blog} = "Addendat cannot delete entries from $blog (at $template{blogfile})";
    return;
  }
  my @entries = open_html_file();
  my $replaced;
  if (@entries) {
    my $x = 1;
    while ($x<$#entries) {
      if (${$entries[$x]}[0] eq $user_input{'entryid'}) {
        splice(@entries,$x,1);
        $replaced = 1;
        last;
      }
      $x++;
    }
    if ($replaced) {
      if ($#entries>1 or !exists($template{blankfile})) {
        save_html_file(@entries);
      } elsif ($entries[0]!~/\<!-- Entry /s && $entries[1]!~/\<!-- Entry /s) {
        my $blogfile = &expand_mcis($template{blogfile});
        rename($blogfile,"$Addendat::template{'dbdir'}/_last_deleted_.$>") or $failed_leaves{$blog} = "Error $! renaming $blogfile";
        close(FILE);
      } else {
        save_html_file(@entries);
      }
      &note_totals($#entries-1) if exists $template{totalinblogs};
    }
  } else {
    $failed_leaves{$blog} = "Deleting entry from leaf $blog: no entries.\n";
    close(FILE);
  }
  $blog = $oldblog;
}

BEGIN
{
        1;
}

1;

