#!/usr/bin/perl -T -w
use BSD::Resource;
use Fcntl qw(:DEFAULT);
use strict;
#
# Addendat
#
# Copyright 2001-2005 Deekoo L., released under GPL v2.
#
# http://deekoo.net/technocracy/addendat/

# libdir should be the directory in which Addendat.pm and
# Addendat.cfg live.
$main::libdir = '/home/deekoo/addendat';

my $CPU_RLIMIT_HIT = 0;

sub cpu_rlimit_hit()
{
  $CPU_RLIMIT_HIT++;
  local *F;
  open(F,">$Addendat::template{dbdir}/_rlimit_hit_");
  close(F);
  &UI::fatalerror("CPU time limit exceeded.\n");
}

my @cpulimit = getrlimit(RLIMIT_CPU);
if (10<$cpulimit[0] && 20<$cpulimit[1]) {

  $SIG{SIGXCPU} = \&cpu_rlimit_hit;
  setrlimit(RLIMIT_CPU,10,20);
}


eval("use lib '$main::libdir\';use Addendat;1;") or &UI::fatalerror("Cannot load Addendat.pm");

# Uncomment this to enable debugging.
#$Addendat::DEBUG=1;

# End config.  Below this point, it's safe to leave everything unchanged.
# 

delete($ENV{PATH});
$ENV{IFS} = ' ';

use CGI -debug;
if ($] < 5.006) {
	eval('use Fcntl qw(:DEFAULT :flock);
	use IO::Seekable;');
} else {
	eval('use Fcntl qw(:DEFAULT :flock :seek);');
}
eval('use URI::Escape;');

$CGI::POST_MAX=1024 * 100;  # max 100K posts
$CGI::DISABLE_UPLOADS = 1;  # no uploads

my $query=new CGI;

my $publicize=$query->param('publicize');
$Addendat::autoparagraph = $query->param('autoparagraph');
if (!defined($Addendat::autoparagraph)) {
  $Addendat::autoparagraph = 0;
}
$Addendat::preview = $query->param('preview');
$Addendat::runtime_mcis{previewreason} = 'User requested to preview entry';
$Addendat::runtime_mcis{remote_addr} = $ENV{REMOTE_ADDR};
$Addendat::preview = 0 unless defined($Addendat::preview);
$Addendat::accesscode_ok = 0;
$Addendat::blog=$query->param('blog');
if (!defined($Addendat::blog)) {
  $Addendat::blog='';
}

$Addendat::DEBUG=$query->param('debug');
if (!defined($Addendat::DEBUG)) {
  $Addendat::DEBUG=0;
}

undef ($/);

&Addendat::init();
&set_user_input();

my $action=$query->param('action');
if (defined($action)) {
  if ($action eq 'comment') {
    &UI::fatalerror("Comment form template not set.") unless exists $Addendat::template{commentform};
    print "Content-type: text/html\n\n";
    print &Addendat::expand_mcis($Addendat::template{commentform});
    print "\n";
    exit;
  } elsif ($action eq 'add') {
    &check_accesscode();
    &Addendat::add_entry($Addendat::blog,$publicize);
#  } elsif ($action eq 'configure') { XXX not yet written.  Probably won't be.
#    &configure_addendat();
  } elsif ($action eq 'delete') {
    &delete_entry();
  } elsif ($action eq 'edit') {
    &edit_entry();
  } elsif ($action eq 'list') {
    &list_entries();
#  } elsif ($action eq 'post') {
#    Addendat::post_entry($Addendat::blog,$publicize);
  } elsif ($action eq 'propagate') {
    &check_accesscode(1) if defined $query->param('accesscode');
    Addendat::propagate_stored_entry($Addendat::blog);
  } elsif ($action eq 'publicize') {
    &Addendat::publicize();
    print "Content-type: text/html\n\n<html><body>: ",
      &Addendat::expand_mcis('%response%'),"</body></html>\n\n";
  } elsif ($action eq 'replace') {
    &Addendat::replace_entry();
  } elsif ($action eq 'test') {
    print "Content-type: text/plain\n\nAddendat\n";
    exit(0);
  } else {
    &UI::fatalerror("Unknown action '$action' specified.\n");
  }
} else {
  print "Content-type: text/html\n\n<html><head>
  <title>Addend&aacute;t</title></head>
  <body><p>Addend&aacute;t CGI script operational.</p>
  <p>No command specified; not doing anything.</p>
  </body></html>\n";
  exit 0;
}

exit 0;

=head2 check_accesscode(nonfatal?)
=cut

sub check_accesscode($)
{
  my $accesscode=$query->param('accesscode');
  if (!defined($accesscode)) {
    $accesscode='';
  }
  if (($accesscode ne $Addendat::template{accesscode}) ||
    (!exists($Addendat::template{accesscode}))) {
    return if $_[0] and !length($accesscode);
    &UI::fatalerror("Invalid access code.");
  }
  $Addendat::accesscode_ok = $accesscode;
}

#sub configure_addendat()
#{
#  if (!defined($Addendat::user_input{'configureaccesscode'})) {
#    print "Content-type: text/html\015\012\015\012<html><head><title>Configuration access code required.</title></head>\n";
#    print "<body bgcolor=\"#000000\" text=\"#cccccc\" link=\"#ffffff\" vlink=\"#aaaaaa\" alink=\"#cc0000\">";
#    print "<p>Access code to configure $Addendat::user_input{'blog'}: <form action=\"%Addendat::template{cgiurl}\" method=post><input type=password name=\"configureaccesscode\"><input type=hidden name=\"blog\" value=\"$Addendat::user_input{'blog'}\"><input type=hidden name=\"action\" value=\"configure\"><input type=submit value=\"configure\"></form></body></html>\n";
#    return;
#  }
#  Addendat::check_configureaccesscode();
#  print "Content-type: text/html\015\012\015\012<html><head><title>Configuring $Addendat::user_input{'blog'}.</title></head>\n";
#  print "<body bgcolor=\"#000000\" text=\"#cccccc\" link=\"#ffffff\" vlink=\"#aaaaaa\" alink=\"#cc0000\">";
#  my $k;
#  for $k (keys(%Addendat::template)) {
#    print "<p>Key $k</p>";
#  }
#  print "</body></html>\n";
#}

sub delete_entry()
{
  &UI::fatalerror("No entry ID specified") unless defined $Addendat::user_input{'entryid'};
  my $entryid = $Addendat::user_input{'entryid'};
  if (!defined($Addendat::user_input{'editaccesscode'})) {
    print "Content-type: text/html\015\012\015\012<html><head><title>Delete entry $entryid?</title></head>
    <body bgcolor=\"#000000\" text=\"#cccccc\" link=\"#ffffff\" vlink=\"#aaaaaa\" alink=\"#cc0000\">
    <p>An access code is required to delete this entry ($entryid, in ",&Addendat::blogname($Addendat::user_input{blog}),').</p>'; 
    print "<form action=\"$Addendat::template{cgiurl}\" method=post>";
    print "<input type=hidden name=\"blog\" value=\"$Addendat::user_input{blog}\">";
    print "<input type=hidden name=\"entryid\" value=\"$entryid\">";
    print 'Access code: <input type=password name="editaccesscode">';
    print '<input type=hidden name="action" value="delete">';
    print '<input type=submit value="Delete Entry"></form><p>Note that this will attempt to delete this blog entry from all local blog files to which it was posted; it will not delete it from HTTP or LiveJournal leaves.  If, after deletion,
    a blog file is empty and Addend&aacute;t is configured with a %blankfile%
    setting for that blog, it will be deleted if, and only if, there are no
    blog entries in it.  This means that comments pages will be deleted with
    the entry that caused them, if there are no remaining comments.  If there
    are comments, they will remain present until deleted.</p><p>The handling of comments is a little confusing - if you want to delete the entry\'s comments, you will want to remove them first.</p><p>To help protect against possible bugs, Addendat will save a backup of the last deleted post, and will generally try to err in favour of keeping information rather than losing information.  That being the case, if it is vitally important that the data be destroyed, you should double-check to ensure that it is, in fact, gone.</p>',"\015\012";
    return;
  }
  Addendat::check_editaccesscode();
  Addendat::delete_entry($Addendat::user_input{'blog'}, $entryid);
}

sub edit_entry()
{
  &UI::fatalerror("No entry ID specified") unless defined $Addendat::user_input{'entryid'};
  my $entryid = $Addendat::user_input{'entryid'};
  if (!defined($Addendat::user_input{'editaccesscode'})) {
    print "Content-type: text/html\015\012\015\012<html><head><title>Editing entry</title></head>
    <body bgcolor=\"#000000\" text=\"#cccccc\" link=\"#ffffff\" vlink=\"#aaaaaa\" alink=\"#cc0000\">";
    print "<p>An access code is required to edit this entry ($entryid, in ",&Addendat::blogname($Addendat::user_input{blog}),').</p>'; 
    print "<form action=\"$Addendat::template{cgiurl}\" method=post>";
    print "<input type=hidden name=\"blog\" value=\"$Addendat::user_input{blog}\">";
    print "<input type=hidden name=\"entryid\" value=\"$entryid\">";
    print 'Access code: <input type=password name="editaccesscode">';
    print '<input type=hidden name="action" value="edit">';
    print '<input type=submit value="Edit Entry"></form></body></html>',"\015\012";
    return;
  }
  Addendat::check_editaccesscode();
  print "Content-type: text/html\015\012\015\012<html><head><title>Editing entry</title></head>
  <body bgcolor=\"#000000\" text=\"#cccccc\" link=\"#ffffff\" vlink=\"#aaaaaa\" alink=\"#cc0000\">";
  print "<h3>Addend&aacute;t: editing blog entry</h3>";
  &Addendat::slurp_stored_input($Addendat::template{dbdir},$Addendat::user_input{'entryid'});
  print "<form method=post action=\"$Addendat::template{cgiurl}\">";
  my $k;
  my @v;
  delete $Addendat::user_input{'action'};
  for $k (keys(%Addendat::user_input)) {
    if (!defined($Addendat::user_input{$k})) {
      print "<p>ERROR: $k exists but undef.</p>";
    }
    $Addendat::user_input{$k}=~s/\015\012/\012/gs;
    $Addendat::user_input{$k}=~s/\015/\012/gs;
    @v=split /\012/,$Addendat::user_input{$k};
    print "<div bgcolor=\"#101010\">$k:<br><textarea name=\"$k\" rows=",(@v?$#v+1:1)," columns=70>";
    print join("\012",@v);
    print "</textarea></div>";
  }
  print "<br>Access code: <input type=password name=\"editaccesscode\"><br>\n";
  print "<input type=submit value=\"Update entry\">\n";
  print '<input type=hidden name="entryid" value="',$entryid,'"><input type=hidden name="action" value="replace">';
  print "</form></body></html>\n";
}

sub set_user_input()
{
  my $p;
  for $p ($query->param()) {
    $Addendat::user_input{$p} = $query->param($p);
  }
  { $Addendat::user_input{$p} if defined $p }
}

sub list_entries()
{
  my $blog = $Addendat::blog;
  print "Content-type: text/html\015\012\015\012<html><head>
  <title>Addendat entry list for $blog</title>
  </head>
  <body>";
  local $^W=0;
#  &UI::fatalerror("O_NOFOLLOW not defined") unless defined $Addendat::O_NOFOLLOW;
  my @entries = &Addendat::open_html_file();
  if (@entries) {
    my $header = shift @entries;
    my $footer = pop @entries;
    if (@entries) {
      my $entry;
      for $entry (@entries) {
        if (defined $$entry[0]) {
          $Addendat::user_input{'entryid'} = $$entry[0];
          $Addendat::user_input{'entry'} = $$entry[1];
          print &Addendat::expand_mcis($Addendat::template{'entrylistitem'});
#          print "<p>Entry $$entry[0] <a href=\"$Addendat::template{cgiurl}";
#          print "?action=edit;entryid=$$entry[0];blog=$blog\">edit</a> <a href=\"$Addendat::template{cgiurl}?action=delete;entryid=$$entry[0];blog=$blog\">delete</a></p>";
        } else {
          print "<p>Entry not editable or deletable: has no entry ID.</p>";
          print "<blockquote>$$entry[1]</blockquote>";
        }
      }
    } else {
      print "<p>No entries in this blog.</p>";
    }
  }
#  if (sysopen(HTML,&Addendat::expand_mcis($Addendat::template{blogfile}), &O_RDONLY|$Addendat::O_NOFOLLOW)) {
#    if (flock(HTML,&Fcntl::LOCK_EX)) {
#      local $/;
#      my $file = <HTML>;
#      my @entries;
#      while ($file=~s/\<\!-- Entry \(\Q$blog\E\) --\>(.*?)<!-- \/Entry \(\Q$blog\E\) --\>//s) {
#        push(@entries, $1);
#      }
#      my $entry;
#      for $entry (@entries) {
#        print "<p>$entry</p>\n";
#      }
#      flock(HTML,&Fcntl::LOCK_UN);
#    } else {
#      print "<p>Unable to lock blog file for $blog.</p>";
#    }
#    close(HTML);
#  } else {
#    print "<p>Unable to open blog file for $blog.</p>";
#  }
  print "</body></html>\n";
}

{
  package UI;
  sub fatalerror()
  {
    print "Content-type: text/html\n\n<html><head><title>Fatal Error</title>
    </head><body><pre>Fatal error: $_[0]\n\n";
    if ($Addendat::blog eq '') {
      print "\n\nDebug: you were trying to add an entry to the default blog.\n";
    } else {
      print "Debug information: the blog-ID you were trying to add to is \"$Addendat::blog\"";
      print ' (the default blog)' unless length $Addendat::blog;
      print ".\n</pre>\n</body></html>\n";
    }
    die "Fatal error: $_[0]\n";
  }

  sub show_entryadded()
  {
    print "Content-type: text/html\015\012\015\012";
    print &Addendat::expand_mcis($Addendat::template{entryadded});
    print "\n";
  }

  sub show_entryreplaced()
  {
    print "Content-type: text/html\015\012\015\012";
    print '<html><head><title>Addendat: entry replaced.</title></head>';
    print '<body><p>Entry replaced.</p>';
    if (%Addendat::failed_leaves) {
      print "<p>However, not all leaves of this entry have been updated.  Errors follow:</p>";
      my $leaf;
      for $leaf (keys(%Addendat::failed_leaves)) {
        print "<p><b>$leaf</b>: $Addendat::failed_leaves{$leaf}</p>";
      }
    }
    print "</body></html>\n";
  }

  sub show_entrydeleted()
  {
    print "Content-type: text/html\015\012\015\012";
    print '<html><head><title>Addendat: entry deleted</title></head>
    <body><p>Entry has been deleted.</p>';
    if (%Addendat::failed_leaves) {
      print "<p>However, not all leaves of this entry have been updated.  Errors follow:</p>";
      my $leaf;
      for $leaf (keys(%Addendat::failed_leaves)) {
        print "<p><b>$leaf</b>: $Addendat::failed_leaves{$leaf}</p>";
      }
    }
    print "</body></html>\n";
  }
}

sub show_failed($)
{
	# $_[0]: Is a main blog entry if 1, one or more leaves if 0.
	print "Content-type: text/html\n\n";
	print "<html><head><title>Addend&aacute;t: Entries failed.</title>\n";
	print "</head><body>\n";
	if ($_[0]) {
		print "<p>Blog entry failed.  Details:</p>\n";
	} else {
		print "<p>Leaf entry failed.  Details:</p>\n";
	}
	my $key;
	foreach $key (keys(%Addendat::failed_leaves)) {
		print "Blog: '$key': $Addendat::failed_leaves{$key}\n";
	}
	if (($_[0]==0) && $publicize) {
		print "<p>Your entry has not been publicized.</p>\n";
		print "<p>If these leaf entries are unimportant, you can go ahead and\n";
		print "publicize your entry by clicking the button below.</p>\n";
		print '<form action="addendat.cgi" method="post">';
		print '<input type=hidden name="action" value="publicize">';
                print '<input type=hidden name="blog" value="'.&Addendat::urlescape($Addendat::blog).'">';
		print '<input type=submit value="Publicize this entry">';
		print '</form>';
	}
	print "</body></html>\n";
	exit;
}
